with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDOMAttribute_Interface is

   procedure Initialize (This : in out IHTMLDOMAttribute_Type) is
   begin
      Set_IID (This, IID_IHTMLDOMAttribute);
   end Initialize;

   function Pointer (This : IHTMLDOMAttribute_Type)
     return Pointer_To_IHTMLDOMAttribute
   is
   begin
      return To_Pointer_To_IHTMLDOMAttribute (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDOMAttribute_Type;
                     Pointer : in     Pointer_To_IHTMLDOMAttribute)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   function Get_nodeName
     (This : IHTMLDOMAttribute_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nodeName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nodeName;

   procedure Put_nodeValue
     (This : IHTMLDOMAttribute_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_nodeValue
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_nodeValue;

   function Get_nodeValue
     (This : IHTMLDOMAttribute_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nodeValue
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nodeValue;

   function Get_specified
     (This : IHTMLDOMAttribute_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_specified
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_specified;

end MSHTML.IHTMLDOMAttribute_Interface;

